/*

 todo: set quantities
 todo: tie widget quntities to game variables
 todo: set up timeline
 todo: set up dynamics
 todo: set up dialogs
 todo: release resources?
 todo: allow events to, like, end the game, or whatever
 todo: playsample doesn't seem to work:/
 todo: when pop bars move left, blood spatter
 todo: as population decreases, blot out parts of the city
 todo: as population increases, add new bits in(i guess)

 todo: ALLOW INGAME RESTART
 */
#include <allegro.h>
#include <iostream>
#include <vector>
#include <list>
#include <time.h>
#include <algorithm>
#include <sstream>
#include "boost/foreach.hpp"

using namespace std;

const int tilesize=10;

#define foreach BOOST_FOREACH

typedef float num;

#include "sound.hpp"
#include "misc.hpp"
#include "timer.hpp"

BITMAP* buffer;
BITMAP* introbmp;
BITMAP* titlebmp;
BITMAP* gamebackground;
BITMAP* mother1[10];
BITMAP* mother2[9];
BITMAP* daughter[6];
BITMAP* doctor;

int showruntimer;
#include "printwrap.h"

const int FADEMAX=180;
bool fade;
int fadecounter;
bool overatfade;
float stopwatch;

bool sceneend;
const int ts=13;
char *statustext="";
bool warover=false;
bool quit=false;
bool leave=false;
int titletimer=0;
bool finishedtitle;
int runframe;

bool prevpressedz=1;
bool showdialogue;
bool showmenu;

vector<string> emergencymessages;

char *nulltext="";



int px;
int py;
int pdir;
bool pmov;

void enable_buttons();


void talkto(int per)
{
	showdialogue=true;
	//	dialoguevector=getdialoguevector(per);
}

void thinkaboutmenu()
{
	showmenu=true;
}

bool talkmode;
bool thinkmode;
bool spacepressed;
string curstring;


int consequences=0;


class IntroLoop
{
public:
	static void initialize()
	{
		playmusic(0);
		speed_count=0;
		titletimer=0;
		finishedtitle=false;
	}

	static bool quitcondition()
	{
		return quit||warover||finishedtitle;
	}

	static void logic()
	{
		titletimer++;

		if (titletimer>160|| (titletimer>30&key[KEY_SPACE]))
		{
			finishedtitle=true;
		}
	}

	static void draw()
	{
		blit(introbmp, buffer, 0, 0, 0, 0, 80, 60);
	}
};

class TitleLoop
{
private:
	static bool begin;
	static int selected;
	static bool upheld;
	static bool downheld;
	static bool spaceheld;
public:
	static void initialize()
	{
		begin=false;
		selected=0;
		upheld=true;
		downheld=true;
		spaceheld=true;
	}

	static void logic()
	{
		if (key[KEY_UP])
		{
			if (!upheld)
			{
				selected=(selected+1)%2;
				upheld=true;
			}
		}
		else
			upheld=false;

		if (key[KEY_DOWN])
		{
			if (!downheld)
			{
				selected=(selected+1)%2;
				downheld=true;
			}
		}
		else
			downheld=false;

		if (key[KEY_SPACE])
		{
			if (!spaceheld)
			{
				if (selected==0)
				{
					begin=true;
				}
			}
		}
		else
			spaceheld=false;

	}

	static bool quitcondition()
	{
		return quit||begin;
	}

	static void draw()
	{
		blit(titlebmp, buffer, 0, 0, 0, 0, 80, 60);
	}

};

bool TitleLoop::begin=false;
int TitleLoop::selected=0;
bool TitleLoop::upheld=false;
bool TitleLoop::downheld=false;
bool TitleLoop::spaceheld=true;

int xmargin=44;
int ymargin=0;



template<class T>
void loop();


float pos;
float vel;
float accel;
int lastposint;
bool runanim;

enum GameState {gs_intro,gs_game,gs_outro};
GameState gamestate;
int cutscenetimer;
struct PosFrame
{
	int pos;
	int frame;
};

PosFrame mpawn;
PosFrame dpawn;
PosFrame doctpawn;

int forwardmover=0;

class GameLoop
{
public:
	static void initialize()
	{
        forwardmover=0;
		pos=0;
		vel=0;
		accel=0;
		spacepressed=true;
		runanim=false;
		runframe=0;
		showruntimer=0;
		stopwatch=0;
		gamestate=gs_intro;
		cutscenetimer=0;
		mpawn.pos=-100;
		mpawn.frame=0;
		dpawn.pos=-100;
		dpawn.frame=0;
		doctpawn.pos=-100;
		doctpawn.frame=0;
		leave=false;
		warover=false;


	}

	static bool quitcondition()
	{
		return quit||leave||warover;
	}

	static void logic()
	{
		if (gamestate==gs_intro && cutscenetimer>720)
			gamestate=gs_game;

		switch (gamestate)
		{
			case gs_intro:
			{
				cutscenetimer++;
				std::cout<<cutscenetimer<<endl;
				if (cutscenetimer<270)
				{
					if (mpawn.pos!=(cutscenetimer/8) -6)
					{
						mpawn.pos=(cutscenetimer/8)-6 ;
						mpawn.frame=(mpawn.frame%8)+1;
					}
				}

				if (cutscenetimer>70 && cutscenetimer<380)
				{
					if (dpawn.pos!=((cutscenetimer-70)/7 -6))
					{
						dpawn.pos=((cutscenetimer-70)/7-6);
						dpawn.frame=(dpawn.frame+1)%4;
					}
				}
				else if (cutscenetimer> 400 && cutscenetimer<440)
				{
					dpawn.frame=4;
				}
				else if (cutscenetimer> 440&&cutscenetimer<542)
				{
					dpawn.frame=5;
				}
				else if (cutscenetimer>542 && cutscenetimer<650)
				{
					forwardmover=(forwardmover+1)%6;
					if (forwardmover==0&&mpawn.pos<38)
					{
						mpawn.pos++;
						mpawn.frame=mpawn.frame%8+1;
					}
				}
				else if (cutscenetimer>650&&cutscenetimer<720)
				{
					dpawn.pos=-100;
					mpawn.frame=9;

				}
			}
				break;
			case gs_game:
			{
			accel=max(accel-0.01f,0.0f);

			if (key[KEY_SPACE])
			{
				if (!spacepressed)
				{
					accel+=0.025f;

					if (vel<0.1f)
						vel=0.1f;
					spacepressed=true;
				}
			}
			else
			{
				spacepressed=false;
			}
			vel+=accel;
			vel=max(vel-0.01f,0.0f);
			pos+=vel;
			if (pos>465.0f)
			{
				pos=465.0f;
				gamestate=gs_outro;
				mpawn.frame=7;
				cutscenetimer=0;
			}

			int newpos=pos;
			if (newpos==lastposint||(showruntimer>10))
			{
				runanim=false;
				showruntimer--;
			}
			else
			{
				lastposint=newpos;
				runanim=true;
				runframe=(runframe+1)%8;
				showruntimer=30;
			}
			stopwatch++;
			}
			break;
			case gs_outro:
			{
				cutscenetimer++;

				if (cutscenetimer>120)
				{
					mpawn.frame=9;
				}

				if (cutscenetimer>160)
				{
					if (key[KEY_SPACE])
						leave=true;
				}

			}
			break;
		}
	}

	static void draw()
	{

		//clear_to_color(buffer, makecol(255,255,255));
		blit(gamebackground, buffer, pos, 0, 0, 0, 80, 60);

		switch (gamestate)
		{

			case gs_intro:
			{
				masked_blit(mother1[mpawn.frame], buffer, 0, 0, mpawn.pos, 35, 7, 10);
				if (dpawn.pos>-10)
				{
					masked_blit(daughter[dpawn.frame], buffer, 0, 0, dpawn.pos, 40, 7, 10);
				}

			}
				break;
			case gs_game:
			{
				masked_blit(mother2[showruntimer>0?runframe+1:0], buffer, 0, 0, 38, 35, 7, 10);
				stringstream s;
				s<<stopwatch/60;
				textout_ex(buffer, font, s.str().c_str(), 2, 2, makecol(100,100,100), makecol(0,0,0));
				if (!(((int)stopwatch/10) % 2))
				{
					textout_ex(buffer,font,"space",2,49,makecol(100,100,100), makecol(0,0,0));
				}
			}
				break;
			case gs_outro:
			{
				stringstream s;
				s<<stopwatch/60;

				if (cutscenetimer>=180)
				{
					clear_to_color(buffer, makecol(0,0,0));
				}
				textout_ex(buffer, font, s.str().c_str(), 2, 2, makecol(100,100,100), makecol(0,0,0));

				if (mpawn.frame==7)
					masked_blit(mother2[mpawn.frame], buffer, 0, 0, mpawn.pos, 35, 7, 10);
				else
					masked_blit(mother1[mpawn.frame], buffer, 0, 0, mpawn.pos, 35, 7, 10);

				if (cutscenetimer>40&&cutscenetimer<180)
					masked_blit(doctor,buffer,0,0,mpawn.pos+7,36,4,9);


			}
				break;
		}
		//start at 5
		//rect(buffer, 10, 30, 10+1000, 40, makecol(0,0,0));
		//end at 1024-5
		//vline(buffer, 10+pos, 30, 40, makecol(255,0,0));


	}

};



template<class T>
void loop()
{

	T::initialize();

	while(!T::quitcondition())
	{
		al_poll_duh(dplay);

		while(speed_count>0)
		{
			poll_mouse();

			if (key[KEY_ESC])
				quit=true;

			T::logic();

			speed_count--;

		}

		T::draw();

		stretch_blit(buffer, screen, 0, 0, 80, 60, 0, 0, 640, 480);
	}
}

void dotransition()
{
}


void init()
{

	/* initialise everything */
	allegro_init();
	init_sound();

	//	int depth = desktop_color_depth();

	//	if (depth == 0) depth = 32;
	//		set_color_depth(depth);
	set_color_depth(32);

	install_keyboard();
	install_mouse();
	install_timer();


	set_alpha_blender();

    LOCK_VARIABLE(speed_counter); //Used to set the timer - which regulates the game's
    LOCK_FUNCTION(increment_speed_counter);//speed.
    install_int_ex(increment_speed_counter, BPS_TO_TIMER(30));

	set_gfx_mode(GFX_AUTODETECT_FULLSCREEN, 640, 480, 0, 0) ;

	//init the buffer
	buffer=create_bitmap(80,60);

	introbmp=load_bitmap("bmp/intro.bmp",NULL);
	titlebmp=load_bitmap("bmp/title.bmp",NULL);
	gamebackground=load_bitmap("bmp/background.bmp",NULL);


	BITMAP* spritesheet = load_bitmap("bmp/spritesheet.bmp", NULL);
	for (int i=0;i<10;i++)
	{
		mother1[i]=create_bitmap(7,10);
		blit(spritesheet,mother1[i],i*7,0,0,0,7,10);
	}

	for (int i=0;i<9;i++)
	{
		mother2[i]=create_bitmap(7,10);
		blit(spritesheet,mother2[i],i*7,10,0,0,7,10);
	}

	for (int i=0;i<6;i++)
	{
		daughter[i]=create_bitmap(5,6);
		blit(spritesheet,daughter[i],i*5,20,0,0,5,6);
	}

	doctor=create_bitmap(4,8);
	blit(spritesheet,doctor,0,26,0,0,4,8);

	delete spritesheet;

	srand(time(0));

}

void drawthinkaboutmenu()
{
	/*
	drawpanel(x,y,blah,blah);
	printtext("think about")
	for (int i=0;i<9;i++)
	{
		blit(entityimage[i],x+tilewidth*(i/3),y+tilewidth*(i%3));
	}
	 */
}

int main(int argc, char *argv[])
{
	init();

	loop<IntroLoop>();


	while (!quit)
	{
		loop<TitleLoop>();

		loop<GameLoop>();

		playmusic(0);
	}

	return 0;
}
END_OF_MAIN()
